#include <sys/wait.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
 
int main(void){
    pid_t pids[10]; // Platz fr 10 Prozess-IDs (die Kindprozesse)
    int i; // Laufvariable
 
    for (i = 0; i < 10; ++i) {
        // Der Vaterprozess erzeugt nun einen Kindprozess,
        // welcher unabhngig vom Vaterprozess mit der
        // erneuten Ausfhrung des Programms beginnt.
        // Ein Kindprozess erzeugt keinen Fork von sich selbst.
        pids[i] = fork();
        if (pids[i] == 0) {
            // dann befinden wir uns in einem der 10 Kindprozesse
            // Der erste Kindprozess wartet 10 Sekunden und jeder
            // weitere Kindprozess wartet 1 Sekunde krzer als der
            // vorige.
            printf ("BRAINS! ");
            sleep(10-i);
            exit(0); // Kindprozess erfolgreich beenden
        }
    }
/*
    // hier kommt nur der Vaterprozess vorbei
    for (i = 0; i < 10; ++i){
        // Der Vaterprozess wartet nun, bis der Reihe nach jeder
        // seiner 10 Kindprozesse beendet ist. Leider wird auf das
        // Kind mit der lngsten Wartezeit zuerst gewartet. Obwohl
        // die anderen Kinder lngst erfolgreich beendet wurden,
        // blockiert das erste Kind eine Bereinigung der Prozesstabelle
        waitpid(pids[i], NULL, 0);
    }
*/
    while (1);
    return 0; // Vaterprozess erfolgreich beenden
}
